
#property  copyright "XXXXX-Neio"
#property  link      ""
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 7
#property  indicator_color1  Yellow
#property  indicator_color2  Yellow
#property  indicator_color3  Red
#property  indicator_color4  Red
#property  indicator_color5  Red
#property  indicator_color6  Orange
#property  indicator_color7  Orange
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_width5  2
#property  indicator_width6  2
#property  indicator_width7  2

//---- indicator parameters
extern double pip=0.005;
extern double pip2=0.0003;
extern double pip3=0.0007;

//---- indicator buffers
double     upper[];
double     lower[];
double     mid[];
double     uppersweet[];
double     lowersweet[];
double     uppersl[];
double     lowersl[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,upper);
   SetIndexBuffer(1,lower);
   SetIndexBuffer(2,mid);
   SetIndexBuffer(3,uppersweet);
   SetIndexBuffer(4,lowersweet);
   SetIndexBuffer(5,uppersl);
   SetIndexBuffer(6,lowersl);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Donchian Channel("+pip+" Pip)");
   SetIndexLabel(0,"Upper");
   SetIndexLabel(1,"Lower");
   SetIndexLabel(2,"Middle");
   SetIndexLabel(3,"UpperSweet");
   SetIndexLabel(4,"LowerSweet");
   SetIndexLabel(3,"UpperSL");
   SetIndexLabel(4,"LowerSL");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| now do the dance.                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- calculate values
   for(int i=limit-1; i>=0; i--) {
      
      if (i==Bars-1)
         {
         upper[i]=High[i];
         lower[i]=upper[i]-pip;
         }
         else
         {
         
         if (High[i]-lower[i+1]>pip) 
            {
            upper[i]=High[i];
            lower[i]=upper[i]-pip;
            }
            
         if (upper[i+1]-Low[i]>pip) 
            {
            lower[i]=Low[i];
            upper[i]=lower[i]+pip;
            }
         
         if ((High[i]-lower[i+1]<=pip) && (upper[i+1]-Low[i]<=pip))
            {
            lower[i]=lower[i+1];
            upper[i]=upper[i+1];
            }
         
         mid[i]=(upper[i]+lower[i])/2;
         uppersweet[i]=mid[i]+pip2;
         lowersweet[i]=mid[i]-pip2;
         uppersl[i]=mid[i]+pip3;
         lowersl[i]=mid[i]-pip3;
         }   

   }
   
   return(0);
  }
  